package com.eactive.eai.adapter.socket2.protocol.law.codec;

import org.apache.mina.common.ByteBuffer;
import org.apache.mina.common.IdleStatus;
import org.apache.mina.common.IoSession;
import org.apache.mina.filter.codec.ProtocolDecoderAdapter;
import org.apache.mina.filter.codec.ProtocolDecoderOutput;

import com.eactive.eai.adapter.EAIException;
import com.eactive.eai.adapter.socket2.common.CommonLib;
import com.eactive.eai.adapter.socket2.config.SocketAdapterContext;
import com.eactive.eai.adapter.socket2.config.SocketLoggerManager;
import com.eactive.eai.adapter.socket2.protocol.ByteMessage;
import com.eactive.eai.adapter.socket2.protocol.ISocketAdapter;
import com.eactive.eai.adapter.socket2.protocol.ProtocolHandler;
import com.eactive.eai.common.util.Logger;

public class LawRecvDecoder extends ProtocolDecoderAdapter  {
	protected final Logger logger;
	protected final Logger errLogger;
	
	public static final int MAX_PAYLOAD_SIZE = 25 * 1024 * 1024;   // 25MB

	private static final String DECODER_STATE_KEY = LawRecvDecoder.class.getName() + ".STATE";

	private enum State {
		STATE_HEADER_READ, STATE_PAYLOAD_READ;
	}

	private static class CodecState {
		State       state = State.STATE_HEADER_READ; 
		ByteBuffer 	buffer = ByteBuffer.allocate(0).setAutoExpand(true);
		int      	payloadSize;
	}
	
	SocketAdapterContext context;
	ISocketAdapter adapter;

	public LawRecvDecoder(ISocketAdapter adapter) {
		this.adapter = adapter;
		this.context = adapter.getContext();

	    logger    = SocketLoggerManager.getInstance().getLogger(context.getAdapterGroupName());
	    errLogger = SocketLoggerManager.getInstance().getErrLogger();
	}

	@SuppressWarnings("static-access")
	public void decode(IoSession session, ByteBuffer in, ProtocolDecoderOutput out) throws Exception {
		CodecState codecState = (CodecState) session.getAttribute(DECODER_STATE_KEY);
		if (codecState == null) {
			codecState = new CodecState();
			codecState.buffer.limit(LawConstants.COMMON_LENGTH);
			session.setAttribute(DECODER_STATE_KEY, codecState);
		}

		if ( context.getTraceLevel() >= context.TRACE_LEVEL_TRACE ) {
			StringBuilder sb = new StringBuilder();
			sb.append("LawRecvDecoder");
			if (codecState.state == State.STATE_PAYLOAD_READ) {
				sb.append("(" + codecState.payloadSize + ")");
			}
			sb.append(" | decode : " + CommonLib.hexDump(in, context));
			logger.debug(sb.toString());
			adapter.addRecentRecvTrace(session, sb.toString());
		}

		while(in.hasRemaining()) {
			session.setIdleTime(IdleStatus.BOTH_IDLE, context.getTimeout());

			switch (codecState.state) {
			case STATE_HEADER_READ:		
				if (readHeader(session, codecState, in)) {
					/**
					 * payload size < 0 인 경우
					 */
					if (codecState.payloadSize < 0) {
						throw new EAIException("RECEAINNA008", context.getAdapterName() +
								" (" + context.getLlFieldType() + "," + context.getLlFieldOffset() + "," + context.getLlFieldLength() +
								") | when read header, ll length field is invalid | " + CommonLib.hexDump(codecState.buffer, context));						
					} 
						
					codecState.state = State.STATE_PAYLOAD_READ;
					session.setAttribute(ProtocolHandler.CODEC_STATE, codecState.state.toString());
				}
				break;
			case STATE_PAYLOAD_READ:
				if (readPayload(session, codecState, in)) {
					byte[] bytes = new byte[codecState.buffer.limit()];
					codecState.buffer.position(0);
					codecState.buffer.get(bytes);
					ByteMessage message = new ByteMessage(bytes);
					out.write(message);
					
					codecState.buffer.position(0).limit(LawConstants.COMMON_LENGTH);
					
					//by short11
					//polling.role 이 Server 가 sender일 경우 오류가 있었음
					if (context.isPollingUse() && context.isPollingSender() && context.isPermanent()) {
						session.setIdleTime(IdleStatus.BOTH_IDLE, context.getPollingTimeout());
					}else{
						session.setIdleTime(IdleStatus.BOTH_IDLE, context.getIdleTimeout());
					}

		 			codecState.state = State.STATE_HEADER_READ;
					session.setAttribute(ProtocolHandler.CODEC_STATE, codecState.state.toString());
				}
				
				break;
			}
			
			session.setAttribute(ProtocolHandler.CODEC_STATE_BUFFER, CommonLib.hexDumpRead(codecState.buffer, context));
		}
	}

	private boolean readHeader(IoSession session, CodecState codecState, ByteBuffer in) throws Exception {

        if (codecState.buffer.remaining() > in.remaining()) {
        	codecState.buffer.put(in);
            return false;
        }

    	while(codecState.buffer.hasRemaining()) {
    		codecState.buffer.put(in.get());
    	}
    	
    	codecState.payloadSize = 0;

		return true;
	}

	private boolean readPayload(IoSession session, CodecState codecState, ByteBuffer in) throws Exception {
		while(in.hasRemaining()){
			byte b = in.get();
			if (b == LawConstants.EOD){
				codecState.buffer.put(b);
				return true;
			}else{
				codecState.buffer.put(b);
			}
		}
		return false;

	}

	
}
